<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_67) on Tue Oct 14 13:30:14 CEST 2014 -->
<title>DPathSearchMod</title>
<meta name="date" content="2014-10-14">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="DPathSearchMod";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/DPathSearchMod.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMacroManager.DPathMacro.html" title="class in fr.inria.alpage.frmgcm.search"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.DPathSearchBaseElement.html" title="class in fr.inria.alpage.frmgcm.search"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?fr/inria/alpage/frmgcm/search/DPathSearchMod.html" target="_top">Frames</a></li>
<li><a href="DPathSearchMod.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">fr.inria.alpage.frmgcm.search</div>
<h2 title="Class DPathSearchMod" class="title">Class DPathSearchMod</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html" title="class in fr.inria.alpage.frmgcm.search">fr.inria.alpage.frmgcm.search.SearchMod</a></li>
<li>
<ul class="inheritance">
<li>fr.inria.alpage.frmgcm.search.DPathSearchMod</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="strong">DPathSearchMod</span>
extends <a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html" title="class in fr.inria.alpage.frmgcm.search">SearchMod</a></pre>
<div class="block">This class handle dpath query search</div>
<dl><dt><span class="strong">Author:</span></dt>
  <dd>buiquang</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Class and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.DPathSearchBaseElement.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchMod.DPathSearchBaseElement</a></strong></code>
<div class="block">Get from the result of an elasticsearch hit (from the prefetch), the base material for the query</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private float</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#_ef">_ef</a></strong></code>
<div class="block">Estimation factor (allow estimating number of result from current number of result)</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private com.mongodb.BasicDBList</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#_result">_result</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>com.mongodb.BasicDBList</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#curPfFilters">curPfFilters</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchUnit</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#dpathProcesses">dpathProcesses</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#entrySet">entrySet</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#neo4jQuery">neo4jQuery</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#originalQuery">originalQuery</a></strong></code>
<div class="block">This is the original query obtained (without macro expansion)</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>com.mongodb.BasicDBList</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#pfFilters">pfFilters</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>com.mongodb.BasicDBObject</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#pfQuery">pfQuery</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>com.mongodb.BasicDBObject</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#prefilter">prefilter</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#query">query</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>com.mongodb.BasicDBList</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#targetDocuments">targetDocuments</a></strong></code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="fields_inherited_from_class_fr.inria.alpage.frmgcm.search.SearchMod">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;fr.inria.alpage.frmgcm.search.<a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html" title="class in fr.inria.alpage.frmgcm.search">SearchMod</a></h3>
<code><a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html#status">status</a></code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#DPathSearchMod(java.lang.String)">DPathSearchMod</a></strong>(java.lang.String&nbsp;query)</code>
<div class="block">Construct a the helper with a query</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#addPreFilter(com.mongodb.BasicDBObject,%20com.mongodb.BasicDBList)">addPreFilter</a></strong>(com.mongodb.BasicDBObject&nbsp;query,
            com.mongodb.BasicDBList&nbsp;filters)</code>
<div class="block">Append a filter to the list of filters</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>com.mongodb.BasicDBList[]</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#addUnionFilter(com.mongodb.BasicDBList)">addUnionFilter</a></strong>(com.mongodb.BasicDBList&nbsp;filters)</code>
<div class="block">Add a OR branch in the elasticsearch filter</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#execute()">execute</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#execute(com.mongodb.BasicDBList)">execute</a></strong>(com.mongodb.BasicDBList&nbsp;sentences)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#expandMacros(java.lang.String)">expandMacros</a></strong>(java.lang.String&nbsp;query)</code>
<div class="block">Expand macro present in the query (ie name starting with '$')</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#exportResult()">exportResult</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#exportResults(com.mongodb.BasicDBList)">exportResults</a></strong>(com.mongodb.BasicDBList&nbsp;list)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>com.mongodb.BasicDBList</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#filter()">filter</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static com.mongodb.BasicDBObject</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#formatResult(com.mongodb.BasicDBList,%20int,%20int,%20int,%20float)">formatResult</a></strong>(com.mongodb.BasicDBList&nbsp;result,
            int&nbsp;from,
            int&nbsp;max,
            int&nbsp;status,
            float&nbsp;ef)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.util.ArrayList&lt;com.mongodb.BasicDBObject&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#getEntrySet(fr.inria.alpage.frmgcm.search.DPathSearchMod.DPathSearchBaseElement)">getEntrySet</a></strong>(<a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.DPathSearchBaseElement.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchMod.DPathSearchBaseElement</a>&nbsp;sentence)</code>
<div class="block">Depending on the entryset defined by the query (nodes, edges or root), return the corresponding elements from the current sentence</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#getJSONResults(int,%20int)">getJSONResults</a></strong>(int&nbsp;from,
              int&nbsp;max)</code>
<div class="block">get a serialized json string of the results</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>com.mongodb.BasicDBObject</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#getResult(int,%20int)">getResult</a></strong>(int&nbsp;from,
         int&nbsp;max)</code>
<div class="block">Retrieve result</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>com.mongodb.BasicDBList</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#getResults()">getResults</a></strong>()</code>
<div class="block">get the result for the query fetched so far</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#initPreFilter()">initPreFilter</a></strong>()</code>
<div class="block">Construct the base structure for elasticsearch filter</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchUnit</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#parseQuery()">parseQuery</a></strong>()</code>
<div class="block">Parse the input query and returns a list of Search Unit process</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private com.mongodb.BasicDBList</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#preFilter()">preFilter</a></strong>()</code>
<div class="block">Using information from <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#parseQuery()"><code>parseQuery()</code></a>, retrieve a set of sentences from elasticsearch index matching some properties of the query</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchUnit</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#processParseTree(fr.inria.alpage.frmgcm.dpp.SimpleNode,%20com.mongodb.BasicDBList)">processParseTree</a></strong>(<a href="../../../../../fr/inria/alpage/frmgcm/dpp/SimpleNode.html" title="class in fr.inria.alpage.frmgcm.dpp">SimpleNode</a>&nbsp;tree,
                com.mongodb.BasicDBList&nbsp;filter)</code>
<div class="block">Parse the tree structure of the query</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchUnit</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#processParseTree(fr.inria.alpage.frmgcm.dpp.SimpleNode,%20boolean,%20com.mongodb.BasicDBList)">processParseTree</a></strong>(<a href="../../../../../fr/inria/alpage/frmgcm/dpp/SimpleNode.html" title="class in fr.inria.alpage.frmgcm.dpp">SimpleNode</a>&nbsp;tree,
                boolean&nbsp;addPreFilter,
                com.mongodb.BasicDBList&nbsp;prefilter)</code>
<div class="block">Parse a node of the tree structure of the query</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#setEntrySet(java.lang.String)">setEntrySet</a></strong>(java.lang.String&nbsp;entrySet)</code>
<div class="block">Set the query entry set</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#setTarget(com.mongodb.BasicDBList)">setTarget</a></strong>(com.mongodb.BasicDBList&nbsp;subcollectionIds)</code>
<div class="block">Set the targeted collections ids</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_fr.inria.alpage.frmgcm.search.SearchMod">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;fr.inria.alpage.frmgcm.search.<a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html" title="class in fr.inria.alpage.frmgcm.search">SearchMod</a></h3>
<code><a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html#get_stopSignal()">get_stopSignal</a>, <a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html#getSearchThread()">getSearchThread</a>, <a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html#set_stopSignal(int)">set_stopSignal</a>, <a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html#setSearchThread(java.lang.Thread)">setSearchThread</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="targetDocuments">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>targetDocuments</h4>
<pre>public&nbsp;com.mongodb.BasicDBList targetDocuments</pre>
</li>
</ul>
<a name="query">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>query</h4>
<pre>public&nbsp;java.lang.String query</pre>
</li>
</ul>
<a name="originalQuery">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>originalQuery</h4>
<pre>public&nbsp;java.lang.String originalQuery</pre>
<div class="block">This is the original query obtained (without macro expansion)</div>
</li>
</ul>
<a name="entrySet">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>entrySet</h4>
<pre>public&nbsp;java.lang.String entrySet</pre>
</li>
</ul>
<a name="prefilter">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>prefilter</h4>
<pre>public&nbsp;com.mongodb.BasicDBObject prefilter</pre>
</li>
</ul>
<a name="pfFilters">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>pfFilters</h4>
<pre>public&nbsp;com.mongodb.BasicDBList pfFilters</pre>
</li>
</ul>
<a name="curPfFilters">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>curPfFilters</h4>
<pre>public&nbsp;com.mongodb.BasicDBList curPfFilters</pre>
</li>
</ul>
<a name="pfQuery">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>pfQuery</h4>
<pre>public&nbsp;com.mongodb.BasicDBObject pfQuery</pre>
</li>
</ul>
<a name="_result">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>_result</h4>
<pre>private&nbsp;com.mongodb.BasicDBList _result</pre>
</li>
</ul>
<a name="neo4jQuery">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>neo4jQuery</h4>
<pre>public&nbsp;java.lang.String neo4jQuery</pre>
</li>
</ul>
<a name="dpathProcesses">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>dpathProcesses</h4>
<pre>private&nbsp;<a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchUnit</a> dpathProcesses</pre>
</li>
</ul>
<a name="_ef">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>_ef</h4>
<pre>private&nbsp;float _ef</pre>
<div class="block">Estimation factor (allow estimating number of result from current number of result)</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="DPathSearchMod(java.lang.String)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>DPathSearchMod</h4>
<pre>public&nbsp;DPathSearchMod(java.lang.String&nbsp;query)</pre>
<div class="block">Construct a the helper with a query</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>query</code> - the dpath query</dd></dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="setTarget(com.mongodb.BasicDBList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTarget</h4>
<pre>public&nbsp;void&nbsp;setTarget(com.mongodb.BasicDBList&nbsp;subcollectionIds)</pre>
<div class="block">Set the targeted collections ids</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>subcollectionIds</code> - </dd></dl>
</li>
</ul>
<a name="initPreFilter()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>initPreFilter</h4>
<pre>private&nbsp;void&nbsp;initPreFilter()</pre>
<div class="block">Construct the base structure for elasticsearch filter</div>
</li>
</ul>
<a name="expandMacros(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>expandMacros</h4>
<pre>public static&nbsp;java.lang.String&nbsp;expandMacros(java.lang.String&nbsp;query)
                                     throws java.lang.Exception</pre>
<div class="block">Expand macro present in the query (ie name starting with '$')</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>query</code> - the dpath query</dd>
<dt><span class="strong">Returns:</span></dt><dd>the dpath query with macro fully expanded</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd></dl>
</li>
</ul>
<a name="parseQuery()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parseQuery</h4>
<pre>public&nbsp;<a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchUnit</a>&nbsp;parseQuery()</pre>
<div class="block">Parse the input query and returns a list of Search Unit process</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search"><code>DPathSearchUnit</code></a> tree root</dd></dl>
</li>
</ul>
<a name="processParseTree(fr.inria.alpage.frmgcm.dpp.SimpleNode, com.mongodb.BasicDBList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>processParseTree</h4>
<pre>private&nbsp;<a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchUnit</a>&nbsp;processParseTree(<a href="../../../../../fr/inria/alpage/frmgcm/dpp/SimpleNode.html" title="class in fr.inria.alpage.frmgcm.dpp">SimpleNode</a>&nbsp;tree,
                               com.mongodb.BasicDBList&nbsp;filter)</pre>
<div class="block">Parse the tree structure of the query</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>tree</code> - the current root of the tree structure</dd><dd><code>filter</code> - the mutable list of filters that will be added while parsing the query parts</dd>
<dt><span class="strong">Returns:</span></dt><dd>the <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search"><code>DPathSearchUnit</code></a> tree root</dd></dl>
</li>
</ul>
<a name="processParseTree(fr.inria.alpage.frmgcm.dpp.SimpleNode, boolean, com.mongodb.BasicDBList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>processParseTree</h4>
<pre>private&nbsp;<a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchUnit</a>&nbsp;processParseTree(<a href="../../../../../fr/inria/alpage/frmgcm/dpp/SimpleNode.html" title="class in fr.inria.alpage.frmgcm.dpp">SimpleNode</a>&nbsp;tree,
                               boolean&nbsp;addPreFilter,
                               com.mongodb.BasicDBList&nbsp;prefilter)</pre>
<div class="block">Parse a node of the tree structure of the query</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>tree</code> - the node of the tree structure</dd><dd><code>addPreFilter</code> - a boolean indicating whether prefilter should be added when parsing the node (set to false when negative filter is applied)</dd><dd><code>prefilter</code> - the mutable list of filters that will be added while parsing the query parts</dd>
<dt><span class="strong">Returns:</span></dt><dd>a <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchUnit.html" title="class in fr.inria.alpage.frmgcm.search"><code>DPathSearchUnit</code></a> tree</dd></dl>
</li>
</ul>
<a name="getEntrySet(fr.inria.alpage.frmgcm.search.DPathSearchMod.DPathSearchBaseElement)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEntrySet</h4>
<pre>public&nbsp;java.util.ArrayList&lt;com.mongodb.BasicDBObject&gt;&nbsp;getEntrySet(<a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.DPathSearchBaseElement.html" title="class in fr.inria.alpage.frmgcm.search">DPathSearchMod.DPathSearchBaseElement</a>&nbsp;sentence)</pre>
<div class="block">Depending on the entryset defined by the query (nodes, edges or root), return the corresponding elements from the current sentence</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>sentence</code> - the current sentence to apply the query on</dd>
<dt><span class="strong">Returns:</span></dt><dd>the list of elements corresponding to the entryset</dd></dl>
</li>
</ul>
<a name="addUnionFilter(com.mongodb.BasicDBList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addUnionFilter</h4>
<pre>public&nbsp;com.mongodb.BasicDBList[]&nbsp;addUnionFilter(com.mongodb.BasicDBList&nbsp;filters)</pre>
<div class="block">Add a OR branch in the elasticsearch filter</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>filters</code> - the current filter object</dd>
<dt><span class="strong">Returns:</span></dt><dd>the two new spawning 'OR' branches of the filter</dd></dl>
</li>
</ul>
<a name="addPreFilter(com.mongodb.BasicDBObject, com.mongodb.BasicDBList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addPreFilter</h4>
<pre>public&nbsp;void&nbsp;addPreFilter(com.mongodb.BasicDBObject&nbsp;query,
                com.mongodb.BasicDBList&nbsp;filters)</pre>
<div class="block">Append a filter to the list of filters</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>query</code> - the new filter (see examples in <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#processParseTree(fr.inria.alpage.frmgcm.dpp.SimpleNode,%20boolean,%20com.mongodb.BasicDBList)"><code>processParseTree(SimpleNode, boolean, BasicDBList)</code></a> and <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#setTarget(com.mongodb.BasicDBList)"><code>setTarget(BasicDBList)</code></a>)</dd><dd><code>filters</code> - the current list of filters (default is the main list of filters <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#pfFilters"><code>pfFilters</code></a>)</dd></dl>
</li>
</ul>
<a name="setEntrySet(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setEntrySet</h4>
<pre>public&nbsp;void&nbsp;setEntrySet(java.lang.String&nbsp;entrySet)</pre>
<div class="block">Set the query entry set</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>entrySet</code> - the entry set (root, edges or nodes)</dd></dl>
</li>
</ul>
<a name="preFilter()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>preFilter</h4>
<pre>private&nbsp;com.mongodb.BasicDBList&nbsp;preFilter()
                                   throws java.lang.Exception</pre>
<div class="block">Using information from <a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.html#parseQuery()"><code>parseQuery()</code></a>, retrieve a set of sentences from elasticsearch index matching some properties of the query</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the complete list of sentences filtered by elasticsearch for this query</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd></dl>
</li>
</ul>
<a name="getResults()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getResults</h4>
<pre>public&nbsp;com.mongodb.BasicDBList&nbsp;getResults()</pre>
<div class="block">get the result for the query fetched so far</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the result of the query</dd></dl>
</li>
</ul>
<a name="getJSONResults(int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getJSONResults</h4>
<pre>public&nbsp;java.lang.String&nbsp;getJSONResults(int&nbsp;from,
                              int&nbsp;max)</pre>
<div class="block">get a serialized json string of the results</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>from</code> - the index of the first result to get</dd><dd><code>max</code> - the number of results to get</dd>
<dt><span class="strong">Returns:</span></dt><dd>a serialized json string of a segment of the results</dd></dl>
</li>
</ul>
<a name="exportResults(com.mongodb.BasicDBList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>exportResults</h4>
<pre>public static&nbsp;java.lang.String&nbsp;exportResults(com.mongodb.BasicDBList&nbsp;list)</pre>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>list</code> - </dd>
<dt><span class="strong">Returns:</span></dt><dd></dd></dl>
</li>
</ul>
<a name="exportResult()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>exportResult</h4>
<pre>public&nbsp;java.lang.String&nbsp;exportResult()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html#exportResult()">exportResult</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html" title="class in fr.inria.alpage.frmgcm.search">SearchMod</a></code></dd>
</dl>
</li>
</ul>
<a name="execute(com.mongodb.BasicDBList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>execute</h4>
<pre>public&nbsp;void&nbsp;execute(com.mongodb.BasicDBList&nbsp;sentences)
             throws java.lang.Exception</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd></dl>
</li>
</ul>
<a name="filter()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filter</h4>
<pre>public&nbsp;com.mongodb.BasicDBList&nbsp;filter()
                               throws java.lang.Exception</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd></dl>
</li>
</ul>
<a name="execute()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>execute</h4>
<pre>public&nbsp;void&nbsp;execute()
             throws java.lang.Exception</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd></dl>
</li>
</ul>
<a name="getResult(int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getResult</h4>
<pre>public&nbsp;com.mongodb.BasicDBObject&nbsp;getResult(int&nbsp;from,
                                  int&nbsp;max)</pre>
<div class="block"><strong>Description copied from class:&nbsp;<code><a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html#getResult(int,%20int)">SearchMod</a></code></strong></div>
<div class="block">Retrieve result</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html#getResult(int,%20int)">getResult</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../fr/inria/alpage/frmgcm/search/SearchMod.html" title="class in fr.inria.alpage.frmgcm.search">SearchMod</a></code></dd>
<dt><span class="strong">Returns:</span></dt><dd></dd></dl>
</li>
</ul>
<a name="formatResult(com.mongodb.BasicDBList, int, int, int, float)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>formatResult</h4>
<pre>public static&nbsp;com.mongodb.BasicDBObject&nbsp;formatResult(com.mongodb.BasicDBList&nbsp;result,
                                     int&nbsp;from,
                                     int&nbsp;max,
                                     int&nbsp;status,
                                     float&nbsp;ef)</pre>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/DPathSearchMod.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMacroManager.DPathMacro.html" title="class in fr.inria.alpage.frmgcm.search"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../../fr/inria/alpage/frmgcm/search/DPathSearchMod.DPathSearchBaseElement.html" title="class in fr.inria.alpage.frmgcm.search"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?fr/inria/alpage/frmgcm/search/DPathSearchMod.html" target="_top">Frames</a></li>
<li><a href="DPathSearchMod.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
